# makefile for wasp, copyright Steven Reiz 1990, 1991
# see wasp.c for further info
# this makefile is for sas/lattice c 5.10, 8/7/91

OS = -DAMIGA
FEATURES = -DDEBUG -DPROFILING
OBJS1 = wasp.o raw.o readiff.o readgif.o operations.o io.o
OBJS2 = wriff.o wriffcount.o wriffdistr.o wriffout.o
OBJS3 = scrsz.o version.o
OBJS  = $(OBJS1) $(OBJS2) $(OBJS3)
PRE1  = wasp.i raw.i readiff.i readgif.i operations.i io.i
PRE2  = wriff.i wriffcount.i wriffdistr.i wriffout.i
PRE3  = scrsz.i
PRE   = $(PRE1) $(PRE2) $(PRE3)
SH1   = wasp.sh raw.sh readiff.sh readgif.sh operations.sh io.sh
SH2   = wriff.sh wriffcount.sh wriffdistr.sh wriffout.sh
SH3   = scrsz.sh
SH    = $(SH1) $(SH2) $(SH3)
PROLOGUE = lib:c.o
LIBS = lib:lcr.lib lib:lcmr.lib lib:lcm.lib lib:lc.lib

#.c.o:
#	lc1 -. -b1 -cafrsw -j132i -r1r $(OS) $(FEATURES) -ot:$*.q $*.c
#	go -. t:$*.q
#	lc2 -. -v -m0 -o$*.o t:$*.q

.c.o:
	lc1 -. -b1 -cafrsw -d4 -j132i -r1r $(OS) $(FEATURES) -ot:$*.q $*.c
	lc2 -. -v -m0 -o$*.o t:$*.q

.c.i:
	lc1 -. -cw -p $(OS) $(FEATURES) -o$*.i $*.c

.i.sh:
	mkproto -o $*.sh -s $*.i

all: wasp waspnd

waspnd: $(OBJS)
	blink SC SD ND TO waspnd FROM $(PROLOGUE) $(OBJS) LIB $(LIBS)

wasp: $(OBJS)
	blink TO wasp FROM $(PROLOGUE) $(OBJS) LIB $(LIBS)

protos: $(PRE) $(SH) proto.h

proto.h: $(PRE)
	mkproto -o proto.h $(PRE)

$(OBJS1) $(OBJS2): wasp.h
$(OBJS2): wriff.h
io.o: errors.h
